#pragma once
#include "../LowLevelAction.h"

namespace layer1
{
  class AttackUnitAction : public LowLevelAction
  {
  public:
    AttackUnitAction(IBehaviorState& state)
      : LowLevelAction(state)
    {
    }
    virtual std::string getDescription() const
    {
      return "Attack-Unit" + getObjectDescription(m_unitToAttack);
    }
    void setUnitToAttack(BWAPI::Unit* unit)
    {
      m_unitToAttack = unit;
    }
    virtual bool execute(BWAPI::Unit* unit) const
    {
      return unit->attack(m_unitToAttack);
    }
  protected:
    BWAPI::Unit* m_unitToAttack;
  };
}