#pragma once
#include "../LowLevelAction.h"

namespace layer1
{
  class LoadUnit : public LowLevelAction
  {
  public:
    LoadUnit(IBehaviorState& state)
      : LowLevelAction(state)
    {
    }
    virtual std::string getDescription() const
    {
      return "Load unit";
    }
    void setUnit(BWAPI::Unit* unit)
    {
      m_unitToLoad = unit;
    }
    virtual bool execute(BWAPI::Unit* unit) const
    {
	    return unit->load(m_unitToLoad);
    }
  protected:
    BWAPI::Unit* m_unitToLoad;
  };
}