#pragma once
#include "../../LowLevelAction.h"

namespace layer1
{
  class ReaverAttack : public LowLevelAction
  {
  public:
    ReaverAttack(IBehaviorState& state)
      : LowLevelAction(state)
    {
    }
    virtual std::string getDescription() const
    {
      return "Attack with a reaver";
    }
    void setTarget(BWAPI::Unit* unit)
    {
      m_target = unit;
    }
    virtual bool execute(BWAPI::Unit* unit) const
    {
	    return unit->attack(m_target);
    }
  protected:
    BWAPI::Unit* m_target;
  };
}