#pragma once
#include "../LowLevelAction.h"

namespace layer1
{
  class StopAction : public LowLevelAction
  {
  public:
    StopAction(IBehaviorState& state)
      : LowLevelAction(state)
    {
    }
    virtual std::string getDescription() const
    {
      return "Stop";
    }
    virtual bool execute(BWAPI::Unit* unit) const
    {
      return unit->stop();
    }
  };
}