#pragma once
#include "../LowLevelAction.h"

namespace layer1
{
  class UnloadAllUnitsAtPosition : public LowLevelAction
  {
  public:
    UnloadAllUnitsAtPosition(IBehaviorState& state)
      : LowLevelAction(state)
    {
    }
    virtual std::string getDescription() const
    {
      return "Unload all units at position";
    }
    void setPosition(BWAPI::Position position)
    {
      m_position = position;
    }
    virtual bool execute(BWAPI::Unit* unit) const
    {
	    return unit->unloadAll(m_position);
    }
  protected:
    BWAPI::Position m_position;
  };
}