#pragma once

#include "Old/EngageEnemies/GroupCarefulAttack/SplitGroupCarefulAttack.h" // Replace by something else
#include <vector>
#include <BWAPI.h>

template<class Behavior>
struct BehaviorChoice;

template<>
struct BehaviorChoice<IEngageEnemies>
{
	static IEngageEnemies* instantiate(const Process* parent, unsigned int initialPriority, const PersistentUnitGroup* group, const UnitGroup& enemyUnits)
	{
	  // Here some kind of analysis of the group / enemies composition should take place in order to choose 
    // the specialized behavior implementation.
    // A general behavior implementation could be used when no correct specialization is available.
    
    return new SplitGroupCarefulAttack(parent, initialPriority, group, enemyUnits); // enemyUnits not used
  }
	
};
