#pragma once
#include "../../../../Utils/FSM/Condition.h"

template<class UnitGroup>
class AllPickedUp : public Condition
{
public:
  AllPickedUp(const UnitGroup* unitToPick)
    : m_unitToPick(unitToPick)
  {
  }

  bool evaluate() const
  {
	  //m_unitToPick->holdPosition();
    // m_unitToPick->end();
    for(UnitGroup::const_iterator i = m_unitToPick->begin();
        i != m_unitToPick->end();
        ++i)
    {
      if(!(*i)->isLoaded())
	    {
        return false;
	    }
    }
    return true;
  }

protected:
  const UnitGroup* const m_unitToPick;

};