#include "stdafx.h"
#include "UnitBehavior.h"
#include "Layer1FSM.h"

const IUnitBehavior::TerminationMode IUnitBehavior::UnitDestroyed;

void IUnitBehavior::executeImpl()
{
  IBehavior::executeImpl();
  Layer1FSMUnitData& data = dynamic_cast<Layer1FSMUnitData&>(Spar->getUnitManager().getUnitData(m_unit));
  data.addBehavior(this);
  m_unitDestroyId = Spar->getUnitManager().subscribeIndividualUnitDestroy(m_unit, &m_unitDestroyEventHandler, NULL);
}
