#pragma once
#include "../../Utils/Component.h"
#include <BWAPI.h>

template <class Layer1GameState>
class Layer1Reactive : public Component
{
public:
  typedef empty<Layer1Reactive> L1UnitData;

  Layer1Reactive(Layer1GameState& layer1GameState)
    : m_layer1GameState(layer1GameState)
  {
  }

  void onStart() {}
  void onFrame() {}
  void onEnd() {}
  void onSendText(std::string text) {}

protected:
  Layer1GameState& m_layer1GameState;
};
