#pragma once
#include "GroupTacticalAction.h"

namespace layer2
{
  class Attack : public virtual GroupTacticalAction
  {
  public:
    Attack(unsigned int priority, const PersistentUnitGroup* initialGroup) // TODO: target
      : GroupTacticalAction(priority, initialGroup)
      , TacticalAction(priority)
      , Process(Spar)
    {
    }

    virtual std::string getName() const
    {
      return "Attack";
    }

  protected:
    virtual void output(std::ostream& out) const
    {
      GroupTacticalAction::output(out);

      out << "Attack(" << getGroup()->getName() << ")";
    }
  };
}

