#pragma once
#include "Build.h"
#include "../../../../PerceptualState/Locations/Static/BaseLocation.h"

namespace layer2
{
  class Expand : public virtual Build
  {
  public:
    Expand(unsigned int priority, BaseLocation* baseLocation)
      : Build(priority, baseLocation, BWAPI::UnitTypes::Protoss_Nexus)
      , GroupTacticalAction(priority)
      , TacticalAction(priority)
      , Process(Spar)
    {
    }

    virtual std::string getName() const
    {
      return "Expand";
    }

  protected:
    virtual void output(std::ostream& out) const
    {
      TacticalAction::output(out);

      out << "Expand(" << *m_location << ")";
    }
  };
}