#pragma once
#include "../../../UnitData.h"

namespace layer2
{
  class GroupTacticalAction;
};

class Layer2UnitData : public virtual UnitData
{
public:
  Layer2UnitData(BWAPI::Unit* unit)
    : UnitData(unit)
    , m_currentAction(NULL)
  { }
  bool proposeAction(layer2::GroupTacticalAction* action, bool force);
  void removeAction(layer2::GroupTacticalAction* action);
  const layer2::GroupTacticalAction* getCurrentAction() const { return m_currentAction; }
private:
  layer2::GroupTacticalAction* m_currentAction;
};
