#pragma once
#include "../../Interface/Actions/Harass.h"
#include "L2GroupTacticalAction.h"

class L2Harass : public virtual layer2::Harass, public L2GroupTacticalAction
{
public:
  L2Harass(unsigned int priority, const PersistentUnitGroup* initialGroup, Location* location)
    : Harass(priority, initialGroup, location)
    , L2GroupTacticalAction(priority, initialGroup)
    , GroupTacticalAction(priority, initialGroup)
    , TacticalAction(priority)
    , Process(Spar)
  {
  }

protected:
  virtual void executeSpecificImpl();
  virtual void cancelSpecificImpl();
  virtual void terminateSpecificImpl();

  virtual void onUnitAddedToGroup(void*, BWAPI::Unit* unit);
  virtual void onUnitRemovedFromGroup(void*, BWAPI::Unit* unit);
};
