#pragma once
#include "../../../../PerceptualState/Locations/Static/AirLocation.h"
#include "L3PrimitiveLocation.h"

class Map;

class L3AirLocation : public virtual AirLocation, public L3PrimitiveLocation 
{
public:
  template <class LocationTypes>
  L3AirLocation(LocationTypes* dummy, Map* parent)
    : AirLocation(dummy, parent)
    , PrimitiveLocation(parent)
    , StaticLocation(parent)
    , L3PrimitiveLocation(parent)
  {
  }
};