#include "stdafx.h"
#include "ManageArmyTask.h"
#include "../Layer3Script.h"

void ManageArmyTask::run()
{
/*
// Unit Power Tests
  bool ownUnit = true;
  bool canBeDetected = true;
  bool groundOnlyRatio = 0.5;

  UnitPower a0 = getUnitPower(BWAPI::UnitTypes::Protoss_Arbiter, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a1 = getUnitPower(BWAPI::UnitTypes::Protoss_Archon, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a2 = getUnitPower(BWAPI::UnitTypes::Protoss_Carrier, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a3 = getUnitPower(BWAPI::UnitTypes::Protoss_Corsair, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a4 = getUnitPower(BWAPI::UnitTypes::Protoss_Dark_Templar, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a5 = getUnitPower(BWAPI::UnitTypes::Protoss_Dark_Archon, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a6 = getUnitPower(BWAPI::UnitTypes::Protoss_Dragoon, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a7 = getUnitPower(BWAPI::UnitTypes::Protoss_High_Templar, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a8 = getUnitPower(BWAPI::UnitTypes::Protoss_Interceptor, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a9 = getUnitPower(BWAPI::UnitTypes::Protoss_Observer, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a10 = getUnitPower(BWAPI::UnitTypes::Protoss_Photon_Cannon, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a11= getUnitPower(BWAPI::UnitTypes::Protoss_Probe, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a12= getUnitPower(BWAPI::UnitTypes::Protoss_Reaver, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a13= getUnitPower(BWAPI::UnitTypes::Protoss_Scarab, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a14= getUnitPower(BWAPI::UnitTypes::Protoss_Scout, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a15= getUnitPower(BWAPI::UnitTypes::Protoss_Shuttle, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower a16= getUnitPower(BWAPI::UnitTypes::Protoss_Zealot, ownUnit, canBeDetected, groundOnlyRatio);

  UnitPower b1 = getUnitPower(BWAPI::UnitTypes::Terran_Battlecruiser, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b2 = getUnitPower(BWAPI::UnitTypes::Terran_Bunker, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b3 = getUnitPower(BWAPI::UnitTypes::Terran_Dropship, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b4 = getUnitPower(BWAPI::UnitTypes::Terran_Firebat, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b5 = getUnitPower(BWAPI::UnitTypes::Terran_Ghost, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b6 = getUnitPower(BWAPI::UnitTypes::Terran_Goliath, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b7 = getUnitPower(BWAPI::UnitTypes::Terran_Marine, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b8 = getUnitPower(BWAPI::UnitTypes::Terran_Medic, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b9 = getUnitPower(BWAPI::UnitTypes::Terran_Missile_Turret, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b10 = getUnitPower(BWAPI::UnitTypes::Terran_Science_Vessel, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b11= getUnitPower(BWAPI::UnitTypes::Terran_SCV, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b12= getUnitPower(BWAPI::UnitTypes::Terran_Siege_Tank_Siege_Mode, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b13= getUnitPower(BWAPI::UnitTypes::Terran_Siege_Tank_Tank_Mode, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b14= getUnitPower(BWAPI::UnitTypes::Terran_Valkyrie, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b15= getUnitPower(BWAPI::UnitTypes::Terran_Vulture, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b16= getUnitPower(BWAPI::UnitTypes::Terran_Vulture_Spider_Mine, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower b17= getUnitPower(BWAPI::UnitTypes::Terran_Wraith, ownUnit, canBeDetected, groundOnlyRatio);
  
  UnitPower c1 = getUnitPower(BWAPI::UnitTypes::Zerg_Broodling, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c2 = getUnitPower(BWAPI::UnitTypes::Zerg_Cocoon, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c3 = getUnitPower(BWAPI::UnitTypes::Zerg_Defiler, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c4 = getUnitPower(BWAPI::UnitTypes::Zerg_Devourer, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c5 = getUnitPower(BWAPI::UnitTypes::Zerg_Drone, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c6 = getUnitPower(BWAPI::UnitTypes::Zerg_Egg, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c7 = getUnitPower(BWAPI::UnitTypes::Zerg_Guardian, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c8 = getUnitPower(BWAPI::UnitTypes::Zerg_Hydralisk, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c9 = getUnitPower(BWAPI::UnitTypes::Zerg_Larva, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c10 = getUnitPower(BWAPI::UnitTypes::Zerg_Lurker, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c11= getUnitPower(BWAPI::UnitTypes::Zerg_Mutalisk, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c12= getUnitPower(BWAPI::UnitTypes::Zerg_Overlord, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c13= getUnitPower(BWAPI::UnitTypes::Zerg_Queen, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c14= getUnitPower(BWAPI::UnitTypes::Zerg_Scourge, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c15= getUnitPower(BWAPI::UnitTypes::Zerg_Sunken_Colony, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c16= getUnitPower(BWAPI::UnitTypes::Zerg_Ultralisk, ownUnit, canBeDetected, groundOnlyRatio);
  UnitPower c17= getUnitPower(BWAPI::UnitTypes::Zerg_Zergling, ownUnit, canBeDetected, groundOnlyRatio);
*/

  
  if (m_mainRegion == NULL)
  {
    std::pair<CompositeLocation::primitive_sub_location_const_iterator, CompositeLocation::primitive_sub_location_const_iterator>
      primitiveLocations = Spar->getPerceptualState().getMap()->getPrimitiveSubLocations();
    for (CompositeLocation::primitive_sub_location_const_iterator it = primitiveLocations.first; it != primitiveLocations.second; ++it)
    {
      RegionLocation* region = dynamic_cast<RegionLocation*>(*it);
      if(region != NULL)
      {
        if(region->getParent()->getAdjacentRegions().size() > 0) // remove Island
        {
          RegionWrapper* rw = new RegionWrapper(region->getParent());
          if(m_layer3Script.getMainBase()->isIn(rw->region))
            m_mainRegion = rw;
          m_regionWrappers.insert(std::make_pair(region->getParent(), rw));
        }
      }
    }
    assert(m_mainRegion != NULL);
  }

  if (m_defendAction == NULL)
  {
    // Defend action at first chokepoint
    BaseLocation* mainBase = m_layer3Script.getMainBase();
    assert(mainBase != NULL);
    Region* region = mainBase->getParent();
    Chokepoint* chokepoint = region->getChokepoints().empty() ? NULL : (*region->getChokepoints().begin()).first;
    if (chokepoint != NULL) {
      m_defendAction = new Defend(400, m_defendGroup, Spar->getPerceptualState().getMap());
    }
    else {
      m_defendAction = new Defend(400, m_defendGroup, Spar->getPerceptualState().getMap());
    }

    m_unitMorphCompletedSubscriberId = Spar->getPerceptualState().getUnitMorphCompletedEvent().subscribe(&m_unitMorphCompletedEventHandler, NULL);
  }

  

  // TODO:
  bool canBeDetected = false;
  double groundRatio = 0.5;
  double minSuperiorityRatio = 0.2;

  // Always attack if we have more than 180 units
  if(BWAPI::Broodwar->self()->supplyUsed() >= 180*2)
    minSuperiorityRatio = -1; 
  
  // TODO: Transfer only if bases are safe
  if(m_attackAction == NULL)
  {
    const PersistentUnitGroup* army = m_defendAction->getGroup();
    if(army->size() >= 12)
    {
      UnitPower armyPower;
      UnitPower unitPower;
      for(PersistentUnitGroup::const_iterator it = army->begin(); it != army->end(); ++it)
      {
        unitPower = getUnitPower((*it)->getType(), true, true, 0.5);
        armyPower.AttackPower += unitPower.AttackPower;
        armyPower.HitPointPower += unitPower.HitPointPower;
      }

      if(armyPower.AttackPower > 0)
      {
        RegionWrapper* target = getAttackLocation(m_mainRegion, armyPower, canBeDetected, groundRatio, minSuperiorityRatio);
        if (target != NULL)
        {
          m_goalRegionAttack = target;
          m_currentRegionAttack = m_goalRegionAttack;
          if(m_currentRegionAttack->fromRegion != NULL)
            while(m_currentRegionAttack->fromRegion->fromRegion != NULL)
              m_currentRegionAttack = m_currentRegionAttack->fromRegion;

          m_attackAction = new AttackMove(PRIORITY_ATTACK_MOVE, m_attackGroup, m_currentRegionAttack->region);
          Process::zombifyOnTerminate(m_attackAction);
          m_attackMoveEndedSubscriberId = m_attackAction->getTerminateEvent().subscribe(&m_attackMoveEndedEventHandler, NULL);
          m_attackAction->execute();
          GroupTacticalAction::transfer(m_defendAction, m_attackAction, m_defendAction->getGroup()->size());
        }
      }
    }
  } else {
    const PersistentUnitGroup* army = m_defendAction->getGroup();
    if(m_defendAction->getGroup()->size() >= 12)
    {
      minSuperiorityRatio = 0.5;
      UnitPower armyPower;
      UnitPower unitPower;
      for(PersistentUnitGroup::const_iterator it = army->begin(); it != army->end(); ++it)
      {
        unitPower = getUnitPower((*it)->getType(), true, true, 0.5);
        armyPower.AttackPower += unitPower.AttackPower;
        armyPower.HitPointPower += unitPower.HitPointPower;
      }

      army = m_attackAction->getGroup();
      for(PersistentUnitGroup::const_iterator it = army->begin(); it != army->end(); ++it)
      {
        unitPower = getUnitPower((*it)->getType(), true, true, 0.5);
        armyPower.AttackPower += unitPower.AttackPower;
        armyPower.HitPointPower += unitPower.HitPointPower;
      }

      if(armyPower.AttackPower > 0)
      {
        RegionWrapper* target = getAttackLocation(m_mainRegion, armyPower, canBeDetected, groundRatio, minSuperiorityRatio);
        if (target != NULL)
        {
          PersistentUnitGroup::const_iterator it = m_defendAction->getGroup()->begin();
          while (it != m_defendAction->getGroup()->end())
          {
            PersistentUnitGroup::const_iterator next = ++(PersistentUnitGroup::const_iterator(it));
            BWAPI::Unit* unit = *it;
            if(unit->getType() != BWAPI::UnitTypes::Protoss_Observer)
              m_attackAction->addUnit(unit, true);
            it = next;
          }
        }
      }
    }
  }
}

void ManageArmyTask::addUnit(BWAPI::Unit* unit)
{
  m_army->insert(unit);

  // Subscribe Defend Ended ?

  // If m_defendAction is NULL, the game is terminated and the action are being deleted
  if(m_defendAction != NULL)
  {
    // The units are removed from the action before we receive the onTerminate callback
    if(m_attackAction != NULL && m_attackAction->isTerminated())
    {
      m_attackGroup->insert(unit);
    } else
    {
      if(unit->getType() == BWAPI::UnitTypes::Protoss_High_Templar)
      {
        if(m_highTemplars->size() > 0)
        {
          BWAPI::Unit* target = (*m_highTemplars->begin());

          assert(unit->canIssueCommand(BWAPI::UnitCommand::useTech(unit, BWAPI::TechTypes::Archon_Warp, target)));
          unit->useTech(BWAPI::TechTypes::Archon_Warp, target);
          m_highTemplars->remove(m_highTemplars->begin());
        } else {
          m_highTemplars->insert(unit);
        }
      } else if(unit->getType() == BWAPI::UnitTypes::Protoss_Observer) {
        if(m_attackingObservers->size() == 0 && m_attackAction != NULL)
        {
          m_attackingObservers->insert(unit);
          m_attackAction->addUnit(unit);
        } else if (m_defendingObservers->size() == 0)
        {
          m_defendingObservers->insert(unit);
          m_defendAction->addUnit(unit);
        } else {
          executeScout(getNewScout(unit));
          m_scoutingObservers->insert(unit);
        }
      } else {
        m_defendAction->addUnit(unit);

        if (m_attackAction != NULL && m_attackAction->isWaitingToExecute())
          m_attackAction->execute();
        if (m_defendAction != NULL && m_defendAction->isWaitingToExecute())
          m_defendAction->execute();
      }
    }
  }
}

void ManageArmyTask::onAttackMoveEnded(void* data)
{
  unused(data);
  assert(m_attackAction != NULL);

  m_attackAction->getTerminateEvent().unsubscribe(m_attackMoveEndedSubscriberId);
  m_attackAction = NULL;

  // TODO:
  bool canBeDetected = false;
  double groundRatio = 0.5;
  double minSuperiorityRatio = 0.2;

  UnitPower armyPower;
  UnitPower unitPower;
  for(PersistentUnitGroup::const_iterator it = m_attackGroup->begin(); it != m_attackGroup->end(); ++it)
  {
    unitPower = getUnitPower((*it)->getType(), true, true, 0.5);
    armyPower.AttackPower += unitPower.AttackPower;
    armyPower.HitPointPower += unitPower.HitPointPower;
  }
  if(armyPower.AttackPower > 0)
  {
    RegionWrapper* target = getAttackLocation(m_currentRegionAttack, armyPower, canBeDetected, groundRatio, minSuperiorityRatio);
    if (target != NULL)
    {
      m_goalRegionAttack = target;
      m_currentRegionAttack = m_goalRegionAttack;
      if(m_currentRegionAttack->fromRegion != NULL)
        while(m_currentRegionAttack->fromRegion->fromRegion != NULL)
          m_currentRegionAttack = m_currentRegionAttack->fromRegion;

      m_attackAction = new AttackMove(50, m_attackGroup, m_currentRegionAttack->region);
      Process::zombifyOnTerminate(m_attackAction);
      m_attackMoveEndedSubscriberId = m_attackAction->getTerminateEvent().subscribe(&m_attackMoveEndedEventHandler, NULL);
      m_attackAction->execute();
    }
  }
}

void ManageArmyTask::OnUnitMorphCompleted(void* data, BWAPI::Unit* unit)
{
  unused(data);

  // Only add the archons. Dark templars should already be in attack or defend group.
  if(unit->getType() == BWAPI::UnitTypes::Protoss_Archon)
    addUnit(unit);
}

ManageArmyTask::RegionWrapper* ManageArmyTask::getAttackLocation(RegionWrapper* fromRegion, UnitPower armyPower, bool canBeDetected, double groundRatio, double minSuperiorityRatio)
{
  // Choose target
  // 1 - Region location with the biggest advantage, accessible without crossing enemy region
  // 2 - Random region if no enemy regions were found
  // TODO: 3 - possible enemy start locations not yet explored (if nothing scouted yet)
  // TODO: 4 - least recently explored base location (instead of random)

  assert(armyPower.AttackPower > 0);
  Map* map = Spar->getPerceptualState().getMap();
  RegionWrapper* target = NULL;
  bool enemyBaseFound = false;

  {
    double maxAdvantage = boost::numeric::bounds<double>::lowest();
    std::list<RegionWrapper*> openNodes = std::list<RegionWrapper*>();
    openNodes.push_back(fromRegion);
    int currentFrame = BWAPI::Broodwar->getFrameCount();
    RegionWrapper* currentRegionWrapper;
    Region* currentRegion;

    fromRegion->lastVisitedFrame = currentFrame;
    fromRegion->fromRegion = NULL;
    while(openNodes.size() > 0)
    {
      currentRegionWrapper = *openNodes.begin();
      openNodes.erase(openNodes.begin());
      assert(currentRegionWrapper->lastVisitedFrame == currentFrame);
      {
        currentRegion = currentRegionWrapper->region;
        currentRegionWrapper->lastVisitedFrame = currentFrame;
        size_t totalNb = currentRegion->getNbEnemyUnits();

        if (totalNb > 0)
        {
          enemyBaseFound = true;
          
          UnitPower regionPower;
          UnitPower unitPower;
          std::pair<StaticLocation::enemy_unit_iterator, StaticLocation::enemy_unit_iterator> enemyUnits = currentRegion->getEnemyUnits();
          for(StaticLocation::enemy_unit_iterator it = enemyUnits.first; it != enemyUnits.second; ++it)
          {
            unitPower = getUnitPower((*it)->getType(), false, canBeDetected, groundRatio);
            regionPower.AttackPower += unitPower.AttackPower;
            regionPower.HitPointPower += unitPower.HitPointPower;
          }

          if(regionPower.AttackPower > 0)
          {
            double ownFrameSurvival = (armyPower.HitPointPower / regionPower.AttackPower);
            double enemyFrameSurvival = (regionPower.HitPointPower / armyPower.AttackPower);

            if(ownFrameSurvival > enemyFrameSurvival * (1 + minSuperiorityRatio))
            {
              double advantage = ownFrameSurvival - enemyFrameSurvival;
              if (advantage > maxAdvantage)
              {
                maxAdvantage = advantage;
                target = currentRegionWrapper;
              }
            }
          } else {
            target = currentRegionWrapper;
            break;
          }
        } else {
          const std::set<std::pair<Region*, Chokepoint*>> adjacents = currentRegion->getAdjacentRegions();
          for(std::set<std::pair<Region*, Chokepoint*>>::const_iterator it = adjacents.begin(); it != adjacents.end(); ++it)
          {
            stdext::hash_map<Region*, RegionWrapper*>::const_iterator wrapperIt = m_regionWrappers.find(it->first);
            assert(wrapperIt != m_regionWrappers.end());
            if(wrapperIt != m_regionWrappers.end())
            {
              if(wrapperIt->second->lastVisitedFrame < currentFrame)
              {
                wrapperIt->second->lastVisitedFrame = currentFrame;
                wrapperIt->second->fromRegion = currentRegionWrapper;
                openNodes.push_back(wrapperIt->second);
              }
            }
          }
        }
      }
    }
  }

  if (enemyBaseFound)
    return target;

  {
    const int randomIndex = rand() % m_regionWrappers.size();
    stdext::hash_map<Region*, RegionWrapper*>::const_iterator it = m_regionWrappers.begin();
    for (int i = 0; i < randomIndex; ++i, ++it);

    target = it->second;
  }

  assert(target != NULL);
  return target;
}

ManageArmyTask::UnitPower ManageArmyTask::getUnitPower(BWAPI::UnitType unitType, bool ownUnit, bool canBeDetected, double groundOnlyRatio) const
{
  //BWAPI::UnitType unitType = unit->getType();
  double attackPower = 0; // approximation of damage per frame
  double hitPointPower = 0;

  double damageFactor = 1;
  double hitPointFactor = 1;
  double rangeFactor = 0.6;
  double maxRange = 384;
  double maxSplashRadius = 100;
  double splashFactor = 0.5;
  double cloakFactor = 1.25;
  if(canBeDetected)
    cloakFactor = 5;
  double flyerFactor = 1 + groundOnlyRatio * groundOnlyRatio;


  // Hardcoded power values
  if(unitType.isBuilding() 
    && unitType != BWAPI::UnitTypes::Protoss_Photon_Cannon
    && unitType != BWAPI::UnitTypes::Zerg_Sunken_Colony
    && unitType != BWAPI::UnitTypes::Terran_Bunker)
  {
    // no power
  } else if(unitType == BWAPI::UnitTypes::Protoss_Probe)
  {
    // no power
  } else if (unitType == BWAPI::UnitTypes::Protoss_High_Templar)
  {
    if(ownUnit)
    {
      // Useless without storm
    } else {
      attackPower += 3;   // Psi Strom
      hitPointPower += hitPointFactor * (unitType.maxHitPoints() + unitType.maxShields());
    }
  } else if (unitType == BWAPI::UnitTypes::Protoss_Scarab)
  {
    // no power
  } else if (unitType == BWAPI::UnitTypes::Protoss_Interceptor)
  {
    // no power
  } else if (unitType == BWAPI::UnitTypes::Terran_SCV)
  {
    // no power
  } else if (unitType == BWAPI::UnitTypes::Terran_Vulture_Spider_Mine)
  {
    // TODO
  } else if (unitType == BWAPI::UnitTypes::Zerg_Broodling)
  {
    // no power
  } else if (unitType == BWAPI::UnitTypes::Zerg_Drone)
  {
    // no power
  } else if (unitType == BWAPI::UnitTypes::Zerg_Queen)
  {
    // TODO
  } else 
  {
    // Special case
    if (unitType == BWAPI::UnitTypes::Protoss_Dark_Archon)
    {
      unitType = BWAPI::UnitTypes::Protoss_Archon;
    } else if (unitType == BWAPI::UnitTypes::Terran_Medic)
    {
      hitPointPower += 150; // heal
    } else if (unitType == BWAPI::UnitTypes::Terran_Siege_Tank_Tank_Mode)
    {
      unitType = BWAPI::UnitTypes::Terran_Siege_Tank_Siege_Mode;
    } else if(unitType == BWAPI::UnitTypes::Terran_Bunker)
    {
      // 4 marines
      damageFactor *= 4;
      // 4 marines + bunker
      hitPointFactor *= 4
        * (unitType.maxHitPoints() + BWAPI::UnitTypes::Terran_Marine.maxHitPoints() + BWAPI::UnitTypes::Terran_Marine.maxShields())
        / (1.0 * (BWAPI::UnitTypes::Terran_Marine.maxHitPoints() + BWAPI::UnitTypes::Terran_Marine.maxShields()));
      unitType = BWAPI::UnitTypes::Terran_Marine;
    } else if (unitType == BWAPI::UnitTypes::Protoss_Carrier)
    {
      // TODO: increase range
      // 8 interceptor. Interceptor cooldown = 1, correct it to 20
      damageFactor *= 8.0 / 20.0;
      hitPointFactor *= 
        (unitType.maxHitPoints() /*+ BWAPI::UnitTypes::Protoss_Interceptor.maxHitPoints() + BWAPI::UnitTypes::Protoss_Interceptor.maxShields()*/)
        / (1.0 * (BWAPI::UnitTypes::Protoss_Interceptor.maxHitPoints() + BWAPI::UnitTypes::Protoss_Interceptor.maxShields()));
      unitType = BWAPI::UnitTypes::Protoss_Interceptor;
    } else if (unitType == BWAPI::UnitTypes::Terran_Science_Vessel)
    {
      attackPower += 2; // Irradiate and EMP Shockwave
      hitPointPower += 250; // Defense matrix
    } else if (unitType == BWAPI::UnitTypes::Zerg_Defiler)
    {
      attackPower += 1; // plague
      hitPointPower += 50; // dark swarm
    }

    BWAPI::WeaponType weapon = unitType.groundWeapon();
    if (unitType == BWAPI::UnitTypes::Protoss_Reaver)
    {
      // TODO: increase range
      weapon = BWAPI::WeaponTypes::Scarab;

      attackPower += damageFactor * (
          weapon.damageAmount() 
          * 1 //unitType.maxGroundHits() 
          * (1 + rangeFactor * 256 /*weapon.maxRange()*/ / maxRange)
          * (1 + splashFactor * weapon.outerSplashRadius() / maxSplashRadius)
        ) / (1.0 * 60 /*weapon.damageCooldown()*/);

      hitPointPower += hitPointFactor * (unitType.maxHitPoints() + unitType.maxShields());
    } else if(weapon != BWAPI::WeaponTypes::None && weapon.damageCooldown() > 0)
    {
      attackPower = damageFactor * (
          weapon.damageAmount() 
          * unitType.maxGroundHits() 
          * (1 + rangeFactor * weapon.maxRange() / maxRange)
          * (1 + splashFactor * weapon.outerSplashRadius() / maxSplashRadius)
        ) / (1.0 * weapon.damageCooldown());

      hitPointPower = hitPointFactor * (unitType.maxHitPoints() + unitType.maxShields());

      if(unitType.hasPermanentCloak() || unitType.cloakingTech() != BWAPI::TechTypes::None)
      {
        hitPointPower *= cloakFactor;
      }

      if(unitType.isFlyer())
      {
        hitPointPower *= flyerFactor;
      }
    } else {
      // no power
    }
  }

  return UnitPower(attackPower, hitPointPower);
}

void ManageArmyTask::executeScout(Scout* scout)
{
  m_scout = scout;
  m_scout->getScoutArrivedEvent().subscribe(&m_scoutArrivedEventHandler, NULL);
  m_scout->execute();
}

void ManageArmyTask::onScoutArrived(void* data, const layer2::Scout* action, StaticLocation* arrivedAtLocation, BWAPI::Unit* unit)
{
  executeScout(getNewScout(unit));
}

Layer3ScriptTypes::Scout* ManageArmyTask::getNewScout(BWAPI::Unit* scout)
{
  L3PrimitiveLocation* target = NULL;
  const int randomIndex = rand() % Spar->getPerceptualState().getMap()->getNbBaseLocations();
  Map::base_location_iterator it = Spar->getPerceptualState().getMap()->baseLocationsBegin();
  for (int i = 0; i < randomIndex; ++i, ++it);
  target = dynamic_cast<L3PrimitiveLocation*>(*it);

  return new Scout(PRIORITY_INITIAL_SCOUT,target,scout);
}