#include "stdafx.h"
#include "L3Tech.h"

Layer3ScriptTypes::TacticalAction* L3UnitTypeTech::instantiateAction(unsigned int priority)
{
  assert(m_unitType.isBuilding());
  return new Layer3ScriptTypes::Build(priority, Spar->getPerceptualState().getMap(), m_unitType);
}

Layer3ScriptTypes::TacticalAction* L3TechTypeTech::instantiateAction(unsigned int priority)
{
  return new Layer3ScriptTypes::TechResearch(priority, this);
}

Layer3ScriptTypes::TacticalAction* L3UpgradeTypeTech::instantiateAction(unsigned int priority)
{
  return new Layer3ScriptTypes::UpgradeResearch(priority, this);
}
