#pragma once
#include "Layer4Task.h"
#include "../../../Layer3Tactical/Interface/ArmyComposition.h"
#include "../../../Layer3Tactical/Interface/TechSet.h"

class UpdateTargetArmyAndTechsTask : public Layer4Task
{
public:
  UpdateTargetArmyAndTechsTask(Layer4Heuristic& layer4Heuristic)
    : Layer4Task(layer4Heuristic)
  {
  }

  void run();

  virtual void runV()
  {
    return run();
  }

private:
  ArmyComposition estimateBestCounter(const Map* map) const;
  TechSet getTargetTechs(const ArmyComposition& armyComposition) const;
  void addImprovementTechs(const ArmyComposition& armyComposition, TechSet& techs) const;
};