#pragma once
#include "../../../Utils/Utils.h"
#include "../../Utils/Component.h"
#include <BWAPI.h>

template <class Layer4StrategicRecognition, class Layer3Tactical>
class Layer4Strategic : public Component
{
public:

  template <class TechType>
  struct TechTypes {};
  template <>
  struct TechTypes<UnitTypeTech> {
    typedef empty<Layer4Strategic> Type;
  };
  template <>
  struct TechTypes<TechTypeTech> {
    typedef empty<Layer4Strategic> Type;
  };
  template <>
  struct TechTypes<UpgradeTypeTech> {
    typedef empty<Layer4Strategic> Type;
  };

  Layer4Strategic(Layer4StrategicRecognition& layer4StrategicRecognition, Layer3Tactical& layer3Tactical)
    : m_layer4StrategicRecognition(layer4StrategicRecognition)
    , m_layer3Tactical(layer3Tactical)
  {
  }

  void onStart() {}
  void onFrame() {}
  void onEnd() {}
  void onSendText(std::string text) {}

protected:
  Layer4StrategicRecognition& m_layer4StrategicRecognition;
  Layer3Tactical& m_layer3Tactical;
};
