#pragma once
#include "PrimitiveLocation.h"

class Map;

class AirLocation : public virtual PrimitiveLocation
{
public:
  template <class LocationTypes>
  AirLocation(LocationTypes*, Map* parent)
    : PrimitiveLocation(parent)
    , StaticLocation(parent)
  {
  }

  virtual bool isInLocation(BWAPI::Position position) const
  {
    unused(position);

    return true;
  }

  virtual BWAPI::Position getCurrentCenter() const;

  virtual void output(std::ostream& out) const
  {
    out << "Air location";
  }
};