#include "stdafx.h"
#include "RegionLocation.h"
#include "Region.h"

BWAPI::Position RegionLocation::getCurrentCenter() const
{
  return getParent()->getCurrentCenter();
}

bool RegionLocation::isInLocation(BWAPI::Position position) const
{
  return getParent()->isInLocation(position);
}

Region* RegionLocation::getParent()
{
  return dynamic_cast<Region*>(m_parent);
}

const Region* RegionLocation::getParent() const
{
  return dynamic_cast<const Region*>(m_parent);
}
