#pragma once
#include "../DecisionMaking/Layer1Reactive/Layer1Reactive.h"

template <class Layer1GameState>
class InactiveLayer1 : public Layer1Reactive<Layer1GameState>
{
public:
  InactiveLayer1(Layer1GameState& layer1GameState)
    : Layer1Reactive(layer1GameState)
  {
  }

  /////////
  // GUI //
  /////////
  typedef IBehavior** BehaviorIterator;
  std::pair<BehaviorIterator, BehaviorIterator> getCurrentBehaviors() const
  {
    return std::make_pair(BehaviorIterator(NULL), BehaviorIterator(NULL));
  }
};
