#pragma once
#include "../DecisionMaking/Layer2Actions/Layer2Actions.h"

template <class Layer2Cueing, class Layer1Reactive>
class InactiveLayer2 : public Layer2Actions<Layer2Cueing, Layer1Reactive>
{
public:
  InactiveLayer2(Layer2Cueing& layer2Cueing, Layer1Reactive& layer1Reactive)
    : Layer2Actions(layer2Cueing, layer1Reactive)
  {
  }

  /////////
  // GUI //
  /////////
  typedef layer2::TacticalAction** ActionIterator;
  std::pair<ActionIterator, ActionIterator> getCurrentActions() const
  {
    return std::make_pair(ActionIterator(NULL), ActionIterator(NULL));
  }
};