#include "stdafx.h"
#include "Timer.h"
#include "WindowsTimer.h"


ITimer *Timer::Create()
{
	return new WindowsTimer;
}

const Timer::value_type Timer::currentTime()
{
	return p_->currentTime();
}

const Timer::value_type Timer::timeFrequency()
{
	return p_->timeFrequency();
}

void Timer::Release(const ITimer *p)
{
	delete p;
}