#ifndef TIMER_H
#define TIMER_H

#include "ITimer.h"

/**
* @brief Utility class to get information about the time.
*/
class Timer
{
	void operator= (const Timer &);
	Timer (const Timer &);

	/**
	* @brief Implementation of the timer of your choice.
	*/
	ITimer *p_;
	static ITimer *Create();
	static void Release(const ITimer *) throw();
public:
  Timer()
		:p_(Create())
	{}

	~Timer() throw()
	{
		Release(p_);
	}
	typedef ITimer::value_type value_type;
	const value_type currentTime();
	const value_type timeFrequency();
};

#endif