#pragma once
#include <SparAIModule.h>
#ifdef USE_SPAR_GUI
  #include <SparQtGui.h>
#endif

template <class S1, class S2, class S3, class S4, class D1, class D2, class D3, class D4>
SparAIModule<S1, S2, S3, S4, D1, D2, D3, D4>* instantiate()
{
  SparAIModule<S1, S2, S3, S4, D1, D2, D3, D4>* spar = new SparAIModule<S1, S2, S3, S4, D1, D2, D3, D4>();
#ifdef USE_SPAR_GUI
  spar->addObserver(new SparQtGUI<S1, S2, S3, S4, D1, D2, D3, D4>(spar));
#endif
  return spar;
}