#pragma once
#include "../LowLevelAction.h"

namespace layer1
{
  class AttackMoveAction : public LowLevelAction
  {
  public:
    AttackMoveAction(IBehaviorState& state)
      : LowLevelAction(state)
    {
    }
    virtual std::string getDescription() const
    {
      return "Attack-Move " + getObjectDescription(m_destination);
    }
    void setDestination(BWAPI::Position destination)
    {
      m_destination = destination;
    }
    virtual bool execute(BWAPI::Unit* unit) const
    {
      return unit->attack(m_destination);
    }
  protected:
    BWAPI::Position m_destination;
  };
}