#include "stdafx.h"
#include "HighTemplarAttack.h"
#include <BWAPI.h>
#include <cassert>

// Engaging state //////////////////////////////////////////////////////////////
HighTemplarAttack::Engaging::Engaging(HighTemplarAttack& behavior)
  : BehaviorState(behavior)
  , m_spellCastedTransition(*this, NoCondition(), NoTransitionAction(), behavior.m_idlingState)
  , m_timerEvent(*this, Scheduler::FSM_SCHEDULING_PRIORITY, 5, 5)
  , m_events(m_timerEvent)
  , m_transitions(m_spellCastedTransition)
{
}

void HighTemplarAttack::Engaging::onEnterImpl()
{
  assert(m_context.m_target != NULL);
  m_unit->useTech(BWAPI::TechTypes::Psionic_Storm,*m_context.m_target);
}

void HighTemplarAttack::Engaging::onExitImpl()
{
}

void DragoonAttackFSM::Engaging::onTimer()
{
  m_context.m_target
  //if target is under storm
  //evaluate
}