//TODO: Needs to be cleaned!!!
#pragma once
#include "../../UnitBehavior.h"
#include "../../BehaviorState.h"
#include "../../Layer1FSM.h"
#include "../../Actions/AttackUnitAction.h"
#include "../../Conditions/CompositeCondition.h"
#include "../../Conditions/HasCriticalHealth.h"
#include "../../Conditions/HasRangedAttack.h"
#include "../../Conditions/IsTargeted.h"
#include "../../Conditions/IsWorthFleeing.h"
#include "../../../../../UnitManager.h"
#include "../../../../../../Utils/ReferenceCounted.h"
#include <BWAPI.h>

class IUnitAttackFSM : public virtual IUnitBehavior
{
public:
  IUnitAttackFSM(const Process* parent, unsigned int initialPriority, BWAPI::Unit* unit)
    : IUnitBehavior(parent, initialPriority, unit)
    , IBehavior(parent, initialPriority)
    , IFSM(parent)
    , Process(parent)
  {
  }

  virtual bool selectTarget(const UnitGroup& enemies) = 0;

  static IUnitAttackFSM* NewAttackFSM(const Process* parent, unsigned int initialPriority, BWAPI::Unit* unit);
};

template <class DerivedBehavior>
class UnitAttackFSM : public virtual IUnitAttackFSM, public UnitBehavior<DerivedBehavior>
{
public:
  UnitAttackFSM(const Process* parent, unsigned int initialPriority, BWAPI::Unit* unit)
    : IUnitAttackFSM(parent, initialPriority, unit)
    , UnitBehavior(parent, initialPriority, unit)
    , IUnitBehavior(parent, initialPriority, unit)
    , IBehavior(parent, initialPriority)
    , IFSM(parent)
    , Process(parent)
  {
  }
};