#pragma once
#include "../../../../Utils/FSM/Condition.h"
#include <BWAPI.h>

struct IsTargeted : Condition
{
  IsTargeted(BWAPI::Unit* unit) : m_unit(unit) {}

  bool evaluate() const
  {
    return Spar->getPerceptualState().isUnitTargeted(m_unit);
  }

private:
  BWAPI::Unit* m_unit;
};