#include "stdafx.h"
#include "GroupTacticalAction.h"

using namespace layer2;

int GroupTacticalAction::transfer(GroupTacticalAction* source, GroupTacticalAction* destination, const int n)
{
  const PersistentUnitGroup* sourceGroup = n > 0 ? source->getGroup() : destination->getGroup();
  const PersistentUnitGroup* destinationGroup = n > 0 ? destination->getGroup() : source->getGroup();
  const int absN = std::abs(n);
  int i = 0;
  PersistentUnitGroup::const_iterator it = sourceGroup->begin();
  while (i < absN && it != sourceGroup->end())
  {
    PersistentUnitGroup::const_iterator next = ++(PersistentUnitGroup::const_iterator(it));
    BWAPI::Unit* unit = *it;
    if (destination->addUnit(unit, true))
    {
      ++i;
    }
    //source->removeUnit(unit);

    it = next;
  }
  return n > 0 ? i : -i;
}