#pragma once
#include "../../Interface/Actions/Expand.h"
#include "L2Build.h"

class L2Expand : public virtual layer2::Expand, public L2Build
{
public:
  L2Expand(unsigned int priority, BaseLocation* baseLocation)
    : Expand(priority, baseLocation)
    , L2Build(priority, baseLocation, BWAPI::UnitTypes::Protoss_Nexus)
    , Build(priority, baseLocation, BWAPI::UnitTypes::Protoss_Nexus)
    , GroupTacticalAction(priority)
    , TacticalAction(priority)
    , Process(Spar)
  {
  }

protected:
  virtual void executeSpecificImpl();
  virtual void cancelSpecificImpl();
  virtual void terminateSpecificImpl();

  virtual void onUnitAddedToGroup(void* data, BWAPI::Unit* unit)
  {
    // TODO
    L2Build::onUnitAddedToGroup(data, unit);
  }
  virtual void onUnitRemovedFromGroup(void* data, BWAPI::Unit* unit)
  {
    // TODO
    L2Build::onUnitRemovedFromGroup(data, unit);
  }
};
