#pragma once
#include "../../Interface/Actions/GroupTacticalAction.h"
#include "L2TacticalAction.h"

class L2GroupTacticalAction : public virtual layer2::GroupTacticalAction, public L2TacticalAction
{
public:
  L2GroupTacticalAction(unsigned int priority, const PersistentUnitGroup* initialGroup)
    : GroupTacticalAction(priority, initialGroup)
    , L2TacticalAction(priority)
    , TacticalAction(priority)
    , Process(Spar)
  {
  }

  L2GroupTacticalAction(unsigned int priority)
    : GroupTacticalAction(priority)
    , L2TacticalAction(priority)
    , TacticalAction(priority)
    , Process(Spar)
  {
  }

protected:
  virtual void executeSpecificImpl()
  {
    L2TacticalAction::executeSpecificImpl();
  }
  virtual void cancelSpecificImpl()
  {
    L2TacticalAction::cancelSpecificImpl();
  }
  virtual void terminateSpecificImpl()
  {
    L2TacticalAction::terminateSpecificImpl();
  }
};
