#pragma once
#include "../../Interface/Actions/Move.h"
#include "L2GroupTacticalAction.h"

class L2Move : public virtual layer2::Move, public L2GroupTacticalAction
{
public:
  L2Move(unsigned int priority, const PersistentUnitGroup* initialGroup, Location* destination)
    : Move(priority, initialGroup, destination)
    , L2GroupTacticalAction(priority, initialGroup)
    , GroupTacticalAction(priority, initialGroup)
    , TacticalAction(priority)
    , Process(Spar)
  {
  }
protected:
  virtual void executeSpecificImpl();
  virtual void cancelSpecificImpl();
  virtual void terminateSpecificImpl();

  virtual void onUnitAddedToGroup(void*, BWAPI::Unit* unit);
  virtual void onUnitRemovedFromGroup(BWAPI::Unit* unit);
};

