#pragma once
#include "../../Interface/Actions/TacticalAction.h"
#include "../Layer2ManagersBase.h"
/**
 * @brief Base class for tactical actions.
 */
class L2TacticalAction : public virtual layer2::TacticalAction
{
public:
  /**
   * @brief Constructs a new tactical action.
   */
  L2TacticalAction(unsigned int priority)
    : TacticalAction(priority)
    , Process(Spar)
    //, m_validActionID(false)
  {
  }

  //void setActionID(Layer2ManagersBase::ActionID id)
  //{
  //  m_validActionID = true;
  //  m_actionID = id;
  //}

  //bool isActionIDValid() const {return m_validActionID;}
  //Layer2ManagersBase::ActionID getActionID() const {return m_actionID;}
protected:
  virtual void executeSpecificImpl();

  virtual void cancelSpecificImpl()
  {
  }

  virtual void terminateSpecificImpl()
  {
  }

  //bool m_validActionID;
  //Layer2ManagersBase::ActionID m_actionID;
};
