#pragma once
#include "../../../../PerceptualState/Locations/Static/BaseLocation.h"
#include "L2PrimitiveLocation.h"

class L2BaseLocation : public virtual BaseLocation, public L2PrimitiveLocation 
{
public:
  template <class LocationTypes>
  L2BaseLocation(LocationTypes* dummy, const BWTA::BaseLocation* location, Region* parent)
    : BaseLocation(dummy, location, parent)
    , PrimitiveLocation(parent)
    , StaticLocation(parent)
    , L2PrimitiveLocation(parent)
  {
  }
};