#pragma once
#include "../../../../PerceptualState/Locations/Static/Chokepoint.h"
#include "L2PrimitiveLocation.h"

class L2Chokepoint: public virtual Chokepoint, public L2PrimitiveLocation
{
public:
  template <class LocationTypes>
  L2Chokepoint(LocationTypes* dummy, BWTA::Chokepoint* chokepoint, Region* firstRegion, Region* secondRegion, Map* parent)
    : Chokepoint(dummy, chokepoint, firstRegion, secondRegion, parent)
    , PrimitiveLocation(parent)
    , StaticLocation(parent)
    , L2PrimitiveLocation(parent)
  {
  }
};