#pragma once
#include "../../../../PerceptualState/Locations/Static/Chokepoint.h"
#include "L3PrimitiveLocation.h"

class L3Chokepoint: public virtual Chokepoint, public L3PrimitiveLocation
{
public:
  template <class LocationTypes>
  L3Chokepoint(LocationTypes* dummy, BWTA::Chokepoint* chokepoint, Region* firstRegion, Region* secondRegion, Map* parent)
    : Chokepoint(dummy, chokepoint, firstRegion, secondRegion, parent)
    , PrimitiveLocation(parent)
    , StaticLocation(parent)
    , L3PrimitiveLocation(parent)
  {
  }
};