#pragma once
#include "../../../../PerceptualState/Locations/Static/RegionLocation.h"
#include "L3PrimitiveLocation.h"

class L3RegionLocation : public virtual RegionLocation, public L3PrimitiveLocation
{
public:
  template <class LocationTypes>
  L3RegionLocation(LocationTypes* dummy, Region* parent)
    : RegionLocation(dummy, parent)
    , L3PrimitiveLocation(parent)
    , PrimitiveLocation(parent)
    , StaticLocation(parent)
  {
  }
};