#include "stdafx.h"
#include "ScoutTask.h"
#include "../Layer3Script.h"

static const size_t NB_PROBES_INITIAL_SCOUT = 9;

void ScoutTask::run()
{
  if (!m_initialScout.hasAlreadyRun() && Spar->getPerceptualState().getMap()->getNbOwnUnits(BWAPI::UnitTypes::Protoss_Probe) >= NB_PROBES_INITIAL_SCOUT)
  {
    Spar->getScheduler().activate(&m_initialScout, Scheduler::SCHEDULING_MEDIUM_PRIORITY, 0, 0);
  }

  // TODO: scout periodically (using visibility influence map?)
}
