#pragma once
#include "../../Utils/Event.h"
#include <BWAPI.h>
#include <iostream>

class Location
{
public:
  virtual ~Location() {}

  // Could be made virtual if necessary
  //bool isInLocation(BWAPI::Position position) const

  friend std::ostream& operator<<(std::ostream& out, const Location& location)
  {
    location.output(out);
    return out;
  }

  virtual BWAPI::Position getCurrentCenter() const = 0;

  virtual bool isInLocation(BWAPI::Position position) const = 0;

protected:
  virtual void output(std::ostream& out) const = 0;
};
