#pragma once
#include "../DecisionMaking/Layer1Reactive/FSM/Behavior.h"
#include "../Utils/Process.h"

class ScenariosBehaviorExecutor : public Component
{
public:
  template <class Layer1>
  static void execute(Layer1& layer1, IBehavior* behavior)
  {
    Process::zombifyOnTerminate(behavior);
    behavior->execute();
  }
  static Process* getParent()
  {
    return Spar;
  }
};