#ifndef ITIMER_H
#define ITIMER_H

/**
 * @brief Base class for a Timer
 */
struct ITimer
{
	typedef long long value_type;
	virtual const value_type currentTime() = 0;
	virtual const value_type timeFrequency() = 0;
protected:
	virtual ~ITimer() throw()
	{}
	friend class Timer;
};
#endif