// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once
#include <Config.h>

//#include "targetver.h"

#define WIN32_LEAN_AND_MEAN             // Exclude rarely-used stuff from Windows headers
// Windows Header Files:
#include <windows.h>
#undef min
#undef max

// C RunTime Header Files
//#include <stdlib.h>
//#include <malloc.h>
//#include <memory.h>
//#include <tchar.h>

#include <iostream>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <functional>
#include <exception>
#include <sstream>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <hash_set>
#include <hash_map>
#include <boost/numeric/conversion/bounds.hpp>
#include <boost/iterator/transform_iterator.hpp>
#include <boost/iterator/filter_iterator.hpp>
#include <boost/tuple/tuple.hpp>

#include <BWAPI.h>

#include "../Utils/Functors.hpp"
#include "../Utils/Utils.h"
#include "Common.h"
#include "Scheduler/Scheduler.h"
#include "Scheduler/SchedulerTask.h"
#include "Scheduler/Timer.h"
#include "DecisionMaking/Layer1Reactive/FSM/Common.h"
#include "DecisionMaking/Layer2Actions/Interface/Common.h"
#include "PerceptualState/Common.h"
#include "PerceptualState/Locations/Common.h"
