#include "stdafx.h"
#include "Process.h"

ProcessWrapper* ProcessWrapper::createWrapper(const Process* process)
{
  const IBehavior* behavior = dynamic_cast<const IBehavior*>(process);
  if (behavior != NULL)
    return new BehaviorWrapper(behavior);
  else
    return new ProcessWrapper(process);
}
